package echo;
import java.rmi.*;
import java.rmi.server.*;
public class EchoServer extends UnicastRemoteObject implements Echo {
	
    public EchoServer( String name ) throws RemoteException {
    	/* (re)bind the remote object instance to the URL input parameter 
    	 * if we rebind the server can be killed and restarted
    	 * without having to restart the rmiregistry */
    	 
    	 try {
    	 	Naming.rebind (name,this);
    	 	} catch (Exception e) {
    	 		System.out.println ("EchoServer.main: exception raised : "+e.getMessage());
    	 		e.printStackTrace();
    	 		}
    }
    
    public String call(String message) throws RemoteException {
    	System.out.println("Echo's method 'call' invoked with message: ["+message+"]");
    	return "From EchoServer:- Got your message: ["+message+"]!";
    	}
    
    public static void main(String args[]) throws Exception {
    	// create and install security manager
    	if (System.getSecurityManager() == null) 
    		System.setSecurityManager ( new RMISecurityManager() );
    	
    	final String URL = "rmi://" + args[0] + "/Echo";
    	
    	/* create a remote EchoServer object:
    	 * recall that the Server object is invoked with argument:
    	 * <host>:end-point */
		 	 
    	EchoServer echo = new EchoServer (URL);
    	
    	System.out.println("EchoServer ready!");
    	}
}